<?php
/**
 * Custom functions that act independently of the theme templates.
 *
 * Eventually, some of the functionality here could be replaced by core features.
 *
 * @package chemical_laboratory
 */

/**
 * Adds custom classes to the array of body classes.
 *
 * @param array $classes Classes for the body element.
 * @return array
 */
function chemical_laboratory_body_classes( $classes ) {
  global $chemical_laboratory_post;
  
    if( !is_page_template( 'template-home.php' ) ){
        $classes[] = 'inner';
        // Adds a class of group-blog to blogs with more than 1 published author.
    }

    if ( is_multi_author() ) {
        $classes[] = 'group-blog ';
    }

    // Adds a class of custom-background-image to sites with a custom background image.
    if ( get_background_image() ) {
        $classes[] = 'custom-background-image';
    }
    
    // Adds a class of custom-background-color to sites with a custom background color.
    if ( get_background_color() != 'ffffff' ) {
        $classes[] = 'custom-background-color';
    }
    

    if( chemical_laboratory_woocommerce_activated() && ( is_shop() || is_product_category() || is_product_tag() || 'product' === get_post_type() ) && ! is_active_sidebar( 'shop-sidebar' ) ){
        $classes[] = 'full-width';
    }    

    // Adds a class of hfeed to non-singular pages.
    if ( ! is_page() ) {
        $classes[] = 'hfeed ';
    }
  
    if( is_404() ||  is_search() ){
        $classes[] = 'full-width';
    }
  
    if( ! is_active_sidebar( 'right-sidebar' ) ) {
        $classes[] = 'full-width'; 
    }

    return $classes;
}
add_filter( 'body_class', 'chemical_laboratory_body_classes' );

 /**
 * 
 * @link http://www.altafweb.com/2011/12/remove-specific-tag-from-php-string.html
 */
function chemical_laboratory_strip_single( $tag, $string ){
    $string=preg_replace('/<'.$tag.'[^>]*>/i', '', $string);
    $string=preg_replace('/<\/'.$tag.'>/i', '', $string);
    return $string;
}

if ( ! function_exists( 'chemical_laboratory_excerpt_more' ) ) :
/**
 * Replaces "[...]" (appended to automatically generated excerpts) with ... * 
 */
function chemical_laboratory_excerpt_more($more) {
  return is_admin() ? $more : ' &hellip; ';
}
endif;
add_filter( 'excerpt_more', 'chemical_laboratory_excerpt_more' );


if( ! function_exists( 'chemical_laboratory_footer_credit' ) ):
/**
 * Footer Credits
*/
function chemical_laboratory_footer_credit() {

    // Check if footer copyright is enabled
    $chemical_laboratory_show_footer_copyright = get_theme_mod( 'chemical_laboratory_footer_setting', true );

    if ( ! $chemical_laboratory_show_footer_copyright ) {
        return; 
    }

    $chemical_laboratory_copyright_text = get_theme_mod('chemical_laboratory_footer_copyright_text');

    $chemical_laboratory_text = '<div class="site-info"><div class="container"><span class="copyright">';
    if ($chemical_laboratory_copyright_text) {
        $chemical_laboratory_text .= wp_kses_post($chemical_laboratory_copyright_text); 
    } else {
        $chemical_laboratory_text .= esc_html__('&copy; ', 'chemical-laboratory') . date_i18n(esc_html__('Y', 'chemical-laboratory')); 
        $chemical_laboratory_text .= ' <a href="' . esc_url(home_url('/')) . '">' . esc_html(get_bloginfo('name')) . '</a>' . esc_html__('. All Rights Reserved.', 'chemical-laboratory');
    }
    $chemical_laboratory_text .= '</span>';
    $chemical_laboratory_text .= '<span class="by"> <a href="' . esc_url('https://www.themeignite.com/products/chemical-laboratory') . '" rel="nofollow" target="_blank">' . CHEMICAL_LABORATORY_THEME_NAME . '</a>' . esc_html__(' By ', 'chemical-laboratory') . '<a href="' . esc_url('https://themeignite.com/') . '" rel="nofollow" target="_blank">' . esc_html__('Themeignite', 'chemical-laboratory') . '</a>.';
    /* translators: %s: link to WordPress.org */
    $chemical_laboratory_text .= sprintf(esc_html__(' Powered By %s', 'chemical-laboratory'), '<a href="' . esc_url(__('https://wordpress.org/', 'chemical-laboratory')) . '" target="_blank">WordPress</a>.');
    if (function_exists('the_privacy_policy_link')) {
        $chemical_laboratory_text .= get_the_privacy_policy_link();
    }
    $chemical_laboratory_text .= '</span></div></div>';
    echo apply_filters('chemical_laboratory_footer_text', $chemical_laboratory_text);
}
add_action('chemical_laboratory_footer', 'chemical_laboratory_footer_credit');
endif;

/**
 * Is Woocommerce activated
*/
if ( ! function_exists( 'chemical_laboratory_woocommerce_activated' ) ) {
  function chemical_laboratory_woocommerce_activated() {
    if ( class_exists( 'woocommerce' ) ) { return true; } else { return false; }
  }
}

if( ! function_exists( 'chemical_laboratory_change_comment_form_default_fields' ) ) :
/**
 * Change Comment form default fields i.e. author, email & url.
 * https://blog.josemcastaneda.com/2016/08/08/copy-paste-hurting-theme/
*/
function chemical_laboratory_change_comment_form_default_fields( $fields ){    
    // get the current commenter if available
    $chemical_laboratory_commenter = wp_get_current_commenter();
 
    // core functionality
    $req      = get_option( 'require_name_email' );
    $chemical_laboratory_aria_req = ( $req ? " aria-required='true'" : '' );
    $chemical_laboratory_required = ( $req ? " required" : '' );
    $chemical_laboratory_author   = ( $req ? __( 'Name*', 'chemical-laboratory' ) : __( 'Name', 'chemical-laboratory' ) );
    $chemical_laboratory_email    = ( $req ? __( 'Email*', 'chemical-laboratory' ) : __( 'Email', 'chemical-laboratory' ) );
 
    // Change just the author field
    $fields['author'] = '<p class="comment-form-author"><label class="screen-reader-text" for="author">' . esc_html__( 'Name', 'chemical-laboratory' ) . '<span class="required">*</span></label><input id="author" name="author" placeholder="' . esc_attr( $chemical_laboratory_author ) . '" type="text" value="' . esc_attr( $chemical_laboratory_commenter['comment_author'] ) . '" size="30"' . $chemical_laboratory_aria_req . $chemical_laboratory_required . ' /></p>';
    
    $fields['email'] = '<p class="comment-form-email"><label class="screen-reader-text" for="email">' . esc_html__( 'Email', 'chemical-laboratory' ) . '<span class="required">*</span></label><input id="email" name="email" placeholder="' . esc_attr( $chemical_laboratory_email ) . '" type="text" value="' . esc_attr(  $chemical_laboratory_commenter['comment_author_email'] ) . '" size="30"' . $chemical_laboratory_aria_req . $chemical_laboratory_required. ' /></p>';
    
    $fields['url'] = '<p class="comment-form-url"><label class="screen-reader-text" for="url">' . esc_html__( 'Website', 'chemical-laboratory' ) . '</label><input id="url" name="url" placeholder="' . esc_attr__( 'Website', 'chemical-laboratory' ) . '" type="text" value="' . esc_attr( $chemical_laboratory_commenter['comment_author_url'] ) . '" size="30" /></p>'; 
    
    return $fields;    
}
endif;
add_filter( 'comment_form_default_fields', 'chemical_laboratory_change_comment_form_default_fields' );

if( ! function_exists( 'chemical_laboratory_change_comment_form_defaults' ) ) :
/**
 * Change Comment Form defaults
 * https://blog.josemcastaneda.com/2016/08/08/copy-paste-hurting-theme/
*/
function chemical_laboratory_change_comment_form_defaults( $defaults ){    
    $defaults['comment_field'] = '<p class="comment-form-comment"><label class="screen-reader-text" for="comment">' . esc_html__( 'Comment', 'chemical-laboratory' ) . '</label><textarea id="comment" name="comment" placeholder="' . esc_attr__( 'Comment', 'chemical-laboratory' ) . '" cols="45" rows="8" aria-required="true" required></textarea></p>';
    
    return $defaults;    
}
endif;
add_filter( 'comment_form_defaults', 'chemical_laboratory_change_comment_form_defaults' );

if( ! function_exists( 'chemical_laboratory_escape_text_tags' ) ) :
/**
 * Remove new line tags from string
 *
 * @param $text
 * @return string
 */
function chemical_laboratory_escape_text_tags( $text ) {
    return (string) str_replace( array( "\r", "\n" ), '', strip_tags( $text ) );
}
endif;

if( ! function_exists( 'wp_body_open' ) ) :
/**
 * Fire the wp_body_open action.
 * Added for backwards compatibility to support pre 5.2.0 WordPress versions.
*/
function wp_body_open() {
    /**
     * Triggered after the opening <body> tag.
    */
    do_action( 'wp_body_open' );
}
endif;

if ( ! function_exists( 'chemical_laboratory_get_fallback_svg' ) ) :    
/**
 * Get Fallback SVG
*/
function chemical_laboratory_get_fallback_svg( $chemical_laboratory_post_thumbnail ) {
    if( ! $chemical_laboratory_post_thumbnail ){
        return;
    }
    
    $chemical_laboratory_image_size = chemical_laboratory_get_image_sizes( $chemical_laboratory_post_thumbnail );
     
    if( $chemical_laboratory_image_size ){ ?>
        <div class="svg-holder">
             <svg class="fallback-svg" viewBox="0 0 <?php echo esc_attr( $chemical_laboratory_image_size['width'] ); ?> <?php echo esc_attr( $chemical_laboratory_image_size['height'] ); ?>" preserveAspectRatio="none">
                    <rect width="<?php echo esc_attr( $chemical_laboratory_image_size['width'] ); ?>" height="<?php echo esc_attr( $chemical_laboratory_image_size['height'] ); ?>" style="fill:#dedddd;"></rect>
            </svg>
        </div>
        <?php
    }
}
endif;

function chemical_laboratory_enqueue_google_fonts() {

    require get_template_directory() . '/inc/wptt-webfont-loader.php';

    wp_enqueue_style(
        'google-fonts-outfit',
        chemical_laboratory_wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Outfit:wght@100..900&display=swap' ),
        array(),
        '1.0'
    );
}
add_action( 'wp_enqueue_scripts', 'chemical_laboratory_enqueue_google_fonts' );


if( ! function_exists( 'chemical_laboratory_site_branding' ) ) :
/**
 * Site Branding
*/
function chemical_laboratory_site_branding(){
    $chemical_laboratory_logo_site_title = get_theme_mod( 'header_site_title', 0 );
    $chemical_laboratory_tagline = get_theme_mod( 'header_tagline', false );
    $chemical_laboratory_logo_width = get_theme_mod('logo_width', 100); // Retrieve the logo width setting

    ?>
    <div class="site-branding" style="max-width: <?php echo esc_attr(get_theme_mod('logo_width', '-1'))?>px;">
        <?php 
        // Check if custom logo is set and display it
        if (function_exists('has_custom_logo') && has_custom_logo()) {
            the_custom_logo();
        }
        if ($chemical_laboratory_logo_site_title):
             if (is_front_page()): ?>
            <h1 class="site-title" style="font-size: <?php echo esc_attr(get_theme_mod('chemical_laboratory_site_title_size', '20')); ?>px;">
            <a href="<?php echo esc_url(home_url('/')); ?>" rel="home"><?php bloginfo('name'); ?></a>
          </h1>
            <?php else: ?>
                <p class="site-title" itemprop="name">
                    <a href="<?php echo esc_url(home_url('/')); ?>" rel="home"><?php bloginfo('name'); ?></a>
                </p>
            <?php endif; ?>
        <?php endif; 
    
        if ($chemical_laboratory_tagline) :
            $chemical_laboratory_description = get_bloginfo('description', 'display');
            if ($chemical_laboratory_description || is_customize_preview()) :
        ?>
                <p class="site-description" itemprop="description"><?php echo $chemical_laboratory_description; ?></p>
            <?php endif;
        endif;
        ?>
    </div>
    <?php
}
endif;
if( ! function_exists( 'chemical_laboratory_navigation' ) ) :
    /**
     * Site Navigation
    */
    function chemical_laboratory_navigation(){
        ?>
        <nav class="main-navigation" id="site-navigation" role="navigation">
            <?php 
            wp_nav_menu( array( 
                'theme_location' => 'primary', 
                'menu_id' => 'primary-menu' 
            ) ); 
            ?>
        </nav>
        <?php
    }
endif;

if( ! function_exists( 'chemical_laboratory_header' ) ) :
    /**
     * Header Start
    */
    function chemical_laboratory_header(){
        $chemical_laboratory_header_image = get_header_image();
        $chemical_laboratory_sticky_header = get_theme_mod('chemical_laboratory_sticky_header');
        $chemical_laboratory_social_icon = get_theme_mod( 'chemical_laboratory_social_icon_setting', false);
        $chemical_laboratory_header_setting     = get_theme_mod( 'chemical_laboratory_header_setting', false );
        $chemical_laboratory_header_btn_url  = get_theme_mod( 'chemical_laboratory_header_btn_url' );
        $chemical_laboratory_header_button_text = get_theme_mod( 'chemical_laboratory_header_button_text', __( 'Book A lab Test', 'chemical-laboratory' ) );
        ?>
        <div id="page-site-header" class="main-header" data-sticky="<?php echo esc_attr( $chemical_laboratory_sticky_header ); ?>">
            <header id="masthead" class="site-header header-inner" role="banner">
                <div class="theme-menu head_bg">
                    <div class="row menu-bg" <?php echo $chemical_laboratory_header_image != '' ? 'style="background-image: url(' . esc_url( $chemical_laboratory_header_image ) . '); background-repeat: no-repeat; background-size: cover"': ""; ?>>
                        <div class="col-xl-2 col-lg-2 col-md-3 col-md-left align-self-center">
                            <?php chemical_laboratory_site_branding(); ?>
                        </div>
                        <div class="col-xl-6 col-lg-6 col-md-1 align-self-center">
                            <?php chemical_laboratory_navigation(); ?> 
                        </div>
                        <div class="col-xl-4 col-lg-4 col-md-8 col-md-right align-self-center head-desc">
                            <div class="header-info">
                                <?php if ( get_theme_mod( 'chemical_laboratory_show_hide_search', false ) ) : ?>
                                    <div class="search-info">
                                        <div class="search-body">
                                            <button type="button" class="search-show">
                                                <i class="<?php echo esc_attr( get_theme_mod( 'chemical_laboratory_search_icon', 'fas fa-search' ) ); ?>"></i>
                                            </button>
                                        </div>
                                        <div class="searchform-inner">
                                            <?php get_search_form(); ?>
                                            <button type="button" class="close" aria-label="<?php esc_attr_e( 'Close', 'chemical-laboratory' ); ?>">
                                                <span aria-hidden="true">X</span>
                                            </button>
                                        </div>
                                    </div>
                                <?php endif; ?>
                                <?php if ( $chemical_laboratory_social_icon ){?>
                                    <div class="social-links">
                                        <?php 
                                        $chemical_laboratory_social_link1 = get_theme_mod( 'chemical_laboratory_social_link_1' );
                                        $chemical_laboratory_social_link2 = get_theme_mod( 'chemical_laboratory_social_link_2' );
                                        $chemical_laboratory_social_link3 = get_theme_mod( 'chemical_laboratory_social_link_3' );
                                        $chemical_laboratory_social_link4 = get_theme_mod( 'chemical_laboratory_social_link_4' );
                                        $chemical_laboratory_social_link5 = get_theme_mod( 'chemical_laboratory_social_link_5' );
                                        if ( ! empty( $chemical_laboratory_social_link1 ) ) {
                                            echo '<a class="social1" href="' . esc_url( $chemical_laboratory_social_link1 ) . '" target="_blank"><i class="fab fa-facebook-f"></i></a>';
                                        }
                                        if ( ! empty( $chemical_laboratory_social_link2 ) ) {
                                            echo '<a class="social2" href="' . esc_url( $chemical_laboratory_social_link2 ) . '" target="_blank"><i class="fa-brands fa-twitter"></i></a>';
                                        } 
                                        if ( ! empty( $chemical_laboratory_social_link3 ) ) {
                                            echo '<a class="social3" href="' . esc_url( $chemical_laboratory_social_link5 ) . '" target="_blank"><i class="fab fa-youtube"></i></a>';
                                        } 
                                        if ( ! empty( $chemical_laboratory_social_link4 ) ) {
                                            echo '<a class="social4" href="' . esc_url( $chemical_laboratory_social_link4 ) . '" target="_blank"><i class="fab fa-instagram"></i></a>';
                                        }
                                        ?>
                                    </div>
                                <?php } ?> 
                                <div class="header-btn">
                                    <?php if ($chemical_laboratory_header_button_text ) : ?>
                                        <a href="<?php echo esc_url( $chemical_laboratory_header_btn_url ); ?>">
                                            <?php echo esc_html( $chemical_laboratory_header_button_text ); ?>
                                            <i class="fas fa-chevron-right"></i>
                                        </a>
                                    <?php endif; ?>
                                </div> 
                            </div>
                        </div>
                    </div>
                </div>                  
            </header>
        </div>
        <?php
    }
endif;
add_action( 'chemical_laboratory_header', 'chemical_laboratory_header', 20 );
